/* vim: set noexpandtab fileencoding=utf-8 nomodified nowrap textwidth=270 foldmethod=marker foldmarker={{{,}}} foldcolumn=4 ruler showcmd lcs=tab\:|- list: */
#ifndef PCF8563_H
#define PCF8563_H
#include "Wire.h"
#include "current_millis.h"
#include <stdint.h>
class PCF8563 {
	public:
		PCF8563();
		bool isPresent(); 	//  test if HW is present
		void setDateTime();		//  year:00..99 dOW: 0=Sunday, 1=Monday, ..., 7=Sunday
		void setDateTime( uint8_t year, uint8_t month, uint8_t day, uint8_t hour, uint8_t minute, uint8_t second, uint8_t dayOfWeek); 	// year:00..99 dOW: 0=Sunday, 1=Monday, ..., 7=Sunday
		void setDateTime(char *Date, char *Time, char dOW);	// "2023.09.07" "15:16:00" 4/"4"
		bool readDateTime();		//  updates variables if possible
		void update();		// do periodic update of time structures
		void updateText();	// parse uints to text
	public:
		uint32_t previous_millis;	// 
		uint8_t year;	// 
		uint8_t month;	// 
		uint8_t day;	// 
		uint8_t hour;	// 
		uint8_t minute;	// 
		uint8_t second;	// 
		uint8_t dayOfWeek;	// 
		bool present;	// 
		char textDate[11];	// 2023.08.31
		char textTime[9];	// 23:45:56
	public:
		static uint8_t daysOfMonths[];	// number of days in month, daysOfMonths[2]=28;
		uint8_t decToBcd(uint8_t val);
		uint8_t bcdToDec(uint8_t val);
		void decTo2char(uint8_t val, char *c);
		void bcdTo2char(uint8_t val, char *c);
			// char arr[]="aa.aa.aa.aa.aaaaaaaa";
			// decTo2char(12,&a[3]);
			// bcdTo2char(0x34,&a[6]);
			// now arr == "aa.12.34.aa.aaaaaaaa"
};
#endif
